#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 133
#define LARGE_STATE_COUNT 13
#define SYMBOL_COUNT 73
#define ALIAS_COUNT 2
#define TOKEN_COUNT 45
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 15

enum ts_symbol_identifiers {
  anon_sym_PIPE = 1,
  sym_any_character = 2,
  anon_sym_CARET = 3,
  sym_end_assertion = 4,
  sym_boundary_assertion = 5,
  sym_non_boundary_assertion = 6,
  anon_sym_LPAREN_QMARK = 7,
  anon_sym_EQ = 8,
  anon_sym_BANG = 9,
  anon_sym_RPAREN = 10,
  anon_sym_LPAREN_QMARK_LT = 11,
  sym_pattern_character = 12,
  anon_sym_LBRACK = 13,
  anon_sym_DASH = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LBRACK_COLON = 16,
  anon_sym_COLON_RBRACK = 17,
  aux_sym_posix_class_name_token1 = 18,
  anon_sym_BSLASH_DASH = 19,
  sym_class_character = 20,
  anon_sym_LPAREN = 21,
  anon_sym_GT = 22,
  anon_sym_LPAREN_QMARK_COLON = 23,
  anon_sym_COLON = 24,
  anon_sym_STAR = 25,
  anon_sym_QMARK = 26,
  anon_sym_PLUS = 27,
  anon_sym_LBRACE = 28,
  anon_sym_COMMA = 29,
  anon_sym_RBRACE = 30,
  anon_sym_BSLASHk = 31,
  anon_sym_LT = 32,
  sym_decimal_escape = 33,
  aux_sym_character_class_escape_token1 = 34,
  aux_sym_character_class_escape_token2 = 35,
  aux_sym_unicode_character_escape_token1 = 36,
  aux_sym_unicode_character_escape_token2 = 37,
  sym_unicode_property = 38,
  aux_sym_control_escape_token1 = 39,
  aux_sym_control_escape_token2 = 40,
  sym_control_letter_escape = 41,
  sym_identity_escape = 42,
  sym_group_name = 43,
  sym_decimal_digits = 44,
  sym_pattern = 45,
  sym_alternation = 46,
  sym_term = 47,
  sym_start_assertion = 48,
  sym_lookaround_assertion = 49,
  sym__lookahead_assertion = 50,
  sym__lookbehind_assertion = 51,
  sym_character_class = 52,
  sym_posix_character_class = 53,
  sym_posix_class_name = 54,
  sym_class_range = 55,
  sym_anonymous_capturing_group = 56,
  sym_named_capturing_group = 57,
  sym_non_capturing_group = 58,
  sym_inline_flags_group = 59,
  sym_flags = 60,
  sym_zero_or_more = 61,
  sym_one_or_more = 62,
  sym_optional = 63,
  sym_count_quantifier = 64,
  sym_backreference_escape = 65,
  sym_character_class_escape = 66,
  sym_unicode_character_escape = 67,
  sym_unicode_property_value_expression = 68,
  sym_control_escape = 69,
  aux_sym_alternation_repeat1 = 70,
  aux_sym_term_repeat1 = 71,
  aux_sym_character_class_repeat1 = 72,
  alias_sym_lazy = 73,
  alias_sym_unicode_property_name = 74,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_PIPE] = "|",
  [sym_any_character] = "any_character",
  [anon_sym_CARET] = "^",
  [sym_end_assertion] = "end_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [anon_sym_LPAREN_QMARK] = "(\?",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG] = "!",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LPAREN_QMARK_LT] = "(\?<",
  [sym_pattern_character] = "pattern_character",
  [anon_sym_LBRACK] = "[",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_COLON] = "[:",
  [anon_sym_COLON_RBRACK] = ":]",
  [aux_sym_posix_class_name_token1] = "posix_class_name_token1",
  [anon_sym_BSLASH_DASH] = "identity_escape",
  [sym_class_character] = "class_character",
  [anon_sym_LPAREN] = "(",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN_QMARK_COLON] = "(\?:",
  [anon_sym_COLON] = ":",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_BSLASHk] = "\\k",
  [anon_sym_LT] = "<",
  [sym_decimal_escape] = "decimal_escape",
  [aux_sym_character_class_escape_token1] = "character_class_escape_token1",
  [aux_sym_character_class_escape_token2] = "character_class_escape_token2",
  [aux_sym_unicode_character_escape_token1] = "unicode_character_escape_token1",
  [aux_sym_unicode_character_escape_token2] = "unicode_character_escape_token2",
  [sym_unicode_property] = "unicode_property_value",
  [aux_sym_control_escape_token1] = "control_escape_token1",
  [aux_sym_control_escape_token2] = "control_escape_token2",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_group_name] = "group_name",
  [sym_decimal_digits] = "decimal_digits",
  [sym_pattern] = "pattern",
  [sym_alternation] = "alternation",
  [sym_term] = "term",
  [sym_start_assertion] = "start_assertion",
  [sym_lookaround_assertion] = "lookaround_assertion",
  [sym__lookahead_assertion] = "_lookahead_assertion",
  [sym__lookbehind_assertion] = "_lookbehind_assertion",
  [sym_character_class] = "character_class",
  [sym_posix_character_class] = "posix_character_class",
  [sym_posix_class_name] = "posix_class_name",
  [sym_class_range] = "class_range",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_inline_flags_group] = "inline_flags_group",
  [sym_flags] = "flags",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_backreference_escape] = "backreference_escape",
  [sym_character_class_escape] = "character_class_escape",
  [sym_unicode_character_escape] = "unicode_character_escape",
  [sym_unicode_property_value_expression] = "unicode_property_value_expression",
  [sym_control_escape] = "control_escape",
  [aux_sym_alternation_repeat1] = "alternation_repeat1",
  [aux_sym_term_repeat1] = "term_repeat1",
  [aux_sym_character_class_repeat1] = "character_class_repeat1",
  [alias_sym_lazy] = "lazy",
  [alias_sym_unicode_property_name] = "unicode_property_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [sym_any_character] = sym_any_character,
  [anon_sym_CARET] = anon_sym_CARET,
  [sym_end_assertion] = sym_end_assertion,
  [sym_boundary_assertion] = sym_boundary_assertion,
  [sym_non_boundary_assertion] = sym_non_boundary_assertion,
  [anon_sym_LPAREN_QMARK] = anon_sym_LPAREN_QMARK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LPAREN_QMARK_LT] = anon_sym_LPAREN_QMARK_LT,
  [sym_pattern_character] = sym_pattern_character,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_COLON] = anon_sym_LBRACK_COLON,
  [anon_sym_COLON_RBRACK] = anon_sym_COLON_RBRACK,
  [aux_sym_posix_class_name_token1] = aux_sym_posix_class_name_token1,
  [anon_sym_BSLASH_DASH] = sym_identity_escape,
  [sym_class_character] = sym_class_character,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LPAREN_QMARK_COLON] = anon_sym_LPAREN_QMARK_COLON,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_BSLASHk] = anon_sym_BSLASHk,
  [anon_sym_LT] = anon_sym_LT,
  [sym_decimal_escape] = sym_decimal_escape,
  [aux_sym_character_class_escape_token1] = aux_sym_character_class_escape_token1,
  [aux_sym_character_class_escape_token2] = aux_sym_character_class_escape_token2,
  [aux_sym_unicode_character_escape_token1] = aux_sym_unicode_character_escape_token1,
  [aux_sym_unicode_character_escape_token2] = aux_sym_unicode_character_escape_token2,
  [sym_unicode_property] = sym_unicode_property,
  [aux_sym_control_escape_token1] = aux_sym_control_escape_token1,
  [aux_sym_control_escape_token2] = aux_sym_control_escape_token2,
  [sym_control_letter_escape] = sym_control_letter_escape,
  [sym_identity_escape] = sym_identity_escape,
  [sym_group_name] = sym_group_name,
  [sym_decimal_digits] = sym_decimal_digits,
  [sym_pattern] = sym_pattern,
  [sym_alternation] = sym_alternation,
  [sym_term] = sym_term,
  [sym_start_assertion] = sym_start_assertion,
  [sym_lookaround_assertion] = sym_lookaround_assertion,
  [sym__lookahead_assertion] = sym__lookahead_assertion,
  [sym__lookbehind_assertion] = sym__lookbehind_assertion,
  [sym_character_class] = sym_character_class,
  [sym_posix_character_class] = sym_posix_character_class,
  [sym_posix_class_name] = sym_posix_class_name,
  [sym_class_range] = sym_class_range,
  [sym_anonymous_capturing_group] = sym_anonymous_capturing_group,
  [sym_named_capturing_group] = sym_named_capturing_group,
  [sym_non_capturing_group] = sym_non_capturing_group,
  [sym_inline_flags_group] = sym_inline_flags_group,
  [sym_flags] = sym_flags,
  [sym_zero_or_more] = sym_zero_or_more,
  [sym_one_or_more] = sym_one_or_more,
  [sym_optional] = sym_optional,
  [sym_count_quantifier] = sym_count_quantifier,
  [sym_backreference_escape] = sym_backreference_escape,
  [sym_character_class_escape] = sym_character_class_escape,
  [sym_unicode_character_escape] = sym_unicode_character_escape,
  [sym_unicode_property_value_expression] = sym_unicode_property_value_expression,
  [sym_control_escape] = sym_control_escape,
  [aux_sym_alternation_repeat1] = aux_sym_alternation_repeat1,
  [aux_sym_term_repeat1] = aux_sym_term_repeat1,
  [aux_sym_character_class_repeat1] = aux_sym_character_class_repeat1,
  [alias_sym_lazy] = alias_sym_lazy,
  [alias_sym_unicode_property_name] = alias_sym_unicode_property_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_pattern_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_posix_class_name_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_DASH] = {
    .visible = true,
    .named = true,
  },
  [sym_class_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHk] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_character_class_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_unicode_property] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_control_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_control_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_digits] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_alternation] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookaround_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym__lookahead_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym__lookbehind_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_posix_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_posix_class_name] = {
    .visible = true,
    .named = true,
  },
  [sym_class_range] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_flags_group] = {
    .visible = true,
    .named = true,
  },
  [sym_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_character_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_property_value_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_control_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_alternation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_term_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_lazy,
  },
  [2] = {
    [1] = sym_class_character,
  },
  [3] = {
    [2] = sym_class_character,
  },
  [4] = {
    [0] = sym_class_character,
    [2] = sym_class_character,
  },
  [5] = {
    [1] = sym_class_character,
    [2] = sym_class_character,
  },
  [6] = {
    [0] = sym_class_character,
  },
  [7] = {
    [3] = alias_sym_lazy,
  },
  [8] = {
    [2] = sym_class_character,
    [3] = sym_class_character,
  },
  [9] = {
    [3] = sym_class_character,
  },
  [10] = {
    [1] = sym_class_character,
    [3] = sym_class_character,
  },
  [11] = {
    [0] = alias_sym_unicode_property_name,
  },
  [12] = {
    [4] = alias_sym_lazy,
  },
  [13] = {
    [2] = sym_class_character,
    [4] = sym_class_character,
  },
  [14] = {
    [5] = alias_sym_lazy,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 35,
  [72] = 72,
  [73] = 43,
  [74] = 21,
  [75] = 22,
  [76] = 33,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 91,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 90,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 112,
  [129] = 129,
  [130] = 130,
  [131] = 129,
  [132] = 123,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(28);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(65);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == ':') ADVANCE(62);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(48);
      if (lookahead == '^') ADVANCE(36);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(34);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead != 0) ADVANCE(45);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(54);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '[') ADVANCE(57);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(48);
      if (lookahead == '^') ADVANCE(36);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '[') ADVANCE(57);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(48);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == ']') ADVANCE(48);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(5);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(5);
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == ':') ADVANCE(61);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == ']') ADVANCE(48);
      if (lookahead == '}') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(7);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(7);
      if (lookahead == '\r') SKIP(6);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == ':') ADVANCE(13);
      if (lookahead == '=') ADVANCE(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(9);
      if (lookahead == '\r') SKIP(8);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '-', 52,
        'B', 39,
        'b', 38,
        'c', 83,
        'k', 69,
        'u', 81,
        'x', 82,
        'P', 73,
        'p', 73,
        '0', 77,
        'f', 77,
        'n', 77,
        'r', 77,
        't', 77,
        'v', 77,
        'D', 72,
        'S', 72,
        'W', 72,
        'd', 72,
        's', 72,
        'w', 72,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(71);
      if (lookahead != 0) ADVANCE(80);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '-', 52,
        'c', 83,
        'u', 81,
        'x', 82,
        'P', 73,
        'p', 73,
        'D', 72,
        'S', 72,
        'W', 72,
        'd', 72,
        's', 72,
        'w', 72,
        '0', 77,
        'b', 77,
        'f', 77,
        'n', 77,
        'r', 77,
        't', 77,
        'v', 77,
      );
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != 'k') ADVANCE(80);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        'B', 39,
        'b', 38,
        'c', 83,
        'k', 69,
        'u', 81,
        'x', 82,
        'P', 73,
        'p', 73,
        '0', 77,
        'f', 77,
        'n', 77,
        'r', 77,
        't', 77,
        'v', 77,
        'D', 72,
        'S', 72,
        'W', 72,
        'd', 72,
        's', 72,
        'w', 72,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(71);
      if (lookahead != 0) ADVANCE(80);
      END_STATE();
    case 13:
      if (lookahead == ']') ADVANCE(50);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        'u', 15,
        'x', 25,
        'P', 73,
        'p', 73,
        'D', 72,
        'S', 72,
        'W', 72,
        'd', 72,
        's', 72,
        'w', 72,
        '0', 77,
        'b', 77,
        'f', 77,
        'n', 77,
        'r', 77,
        't', 77,
        'v', 77,
      );
      END_STATE();
    case 15:
      if (lookahead == '{') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(75);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (lookahead == '}') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (lookahead == '}') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(26);
      END_STATE();
    case 28:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 29:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(30);
      END_STATE();
    case 30:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(30);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '^') ADVANCE(36);
      if (lookahead == '|') ADVANCE(34);
      if (lookahead != 0 &&
          (lookahead < '(' || '+' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(45);
      END_STATE();
    case 31:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(32);
      END_STATE();
    case 32:
      if (eof) ADVANCE(33);
      if (lookahead == '\n') SKIP(32);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(65);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '?') ADVANCE(64);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '^') ADVANCE(36);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(34);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_boundary_assertion);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK);
      if (lookahead == ':') ADVANCE(60);
      if (lookahead == '<') ADVANCE(44);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_LT);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_pattern_character);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ':') ADVANCE(49);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LBRACK_COLON);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON_RBRACK);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_posix_class_name_token1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_BSLASH_DASH);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_class_character);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(54);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead == '[') ADVANCE(57);
      if (lookahead == '^') ADVANCE(36);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(53);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead == '[') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || ']' < lookahead)) ADVANCE(53);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead == '\r') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '-' &&
          lookahead != '\\' &&
          lookahead != ']') ADVANCE(53);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == ':') ADVANCE(49);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '?') ADVANCE(40);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_COLON);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ']') ADVANCE(50);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_BSLASHk);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_decimal_escape);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token1);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token2);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token1);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token2);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_control_escape_token1);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_control_escape_token2);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_control_letter_escape);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identity_escape);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identity_escape);
      if (lookahead == '{') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(79);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_group_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_decimal_digits);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 30},
  [2] = {.lex_state = 30},
  [3] = {.lex_state = 30},
  [4] = {.lex_state = 30},
  [5] = {.lex_state = 30},
  [6] = {.lex_state = 30},
  [7] = {.lex_state = 30},
  [8] = {.lex_state = 30},
  [9] = {.lex_state = 30},
  [10] = {.lex_state = 30},
  [11] = {.lex_state = 30},
  [12] = {.lex_state = 30},
  [13] = {.lex_state = 32},
  [14] = {.lex_state = 32},
  [15] = {.lex_state = 32},
  [16] = {.lex_state = 32},
  [17] = {.lex_state = 32},
  [18] = {.lex_state = 32},
  [19] = {.lex_state = 32},
  [20] = {.lex_state = 32},
  [21] = {.lex_state = 32},
  [22] = {.lex_state = 32},
  [23] = {.lex_state = 32},
  [24] = {.lex_state = 32},
  [25] = {.lex_state = 32},
  [26] = {.lex_state = 32},
  [27] = {.lex_state = 32},
  [28] = {.lex_state = 32},
  [29] = {.lex_state = 32},
  [30] = {.lex_state = 32},
  [31] = {.lex_state = 32},
  [32] = {.lex_state = 32},
  [33] = {.lex_state = 32},
  [34] = {.lex_state = 32},
  [35] = {.lex_state = 32},
  [36] = {.lex_state = 32},
  [37] = {.lex_state = 32},
  [38] = {.lex_state = 32},
  [39] = {.lex_state = 32},
  [40] = {.lex_state = 32},
  [41] = {.lex_state = 32},
  [42] = {.lex_state = 32},
  [43] = {.lex_state = 32},
  [44] = {.lex_state = 30},
  [45] = {.lex_state = 30},
  [46] = {.lex_state = 30},
  [47] = {.lex_state = 30},
  [48] = {.lex_state = 30},
  [49] = {.lex_state = 30},
  [50] = {.lex_state = 30},
  [51] = {.lex_state = 30},
  [52] = {.lex_state = 30},
  [53] = {.lex_state = 30},
  [54] = {.lex_state = 30},
  [55] = {.lex_state = 30},
  [56] = {.lex_state = 30},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 2},
  [59] = {.lex_state = 2},
  [60] = {.lex_state = 2},
  [61] = {.lex_state = 2},
  [62] = {.lex_state = 2},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 2},
  [65] = {.lex_state = 2},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 2},
  [68] = {.lex_state = 2},
  [69] = {.lex_state = 2},
  [70] = {.lex_state = 2},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 2},
  [73] = {.lex_state = 2},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 2},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 5},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 5},
  [87] = {.lex_state = 5},
  [88] = {.lex_state = 7},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 9},
  [91] = {.lex_state = 5},
  [92] = {.lex_state = 5},
  [93] = {.lex_state = 5},
  [94] = {.lex_state = 5},
  [95] = {.lex_state = 5},
  [96] = {.lex_state = 5},
  [97] = {.lex_state = 5},
  [98] = {.lex_state = 5},
  [99] = {.lex_state = 5},
  [100] = {.lex_state = 5},
  [101] = {.lex_state = 5},
  [102] = {.lex_state = 9},
  [103] = {.lex_state = 5},
  [104] = {.lex_state = 5},
  [105] = {.lex_state = 5},
  [106] = {.lex_state = 0},
  [107] = {.lex_state = 7},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 5},
  [110] = {.lex_state = 9},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 7},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 5},
  [116] = {.lex_state = 5},
  [117] = {.lex_state = 5},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 7},
  [121] = {.lex_state = 5},
  [122] = {.lex_state = 5},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 5},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 5},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 7},
  [129] = {.lex_state = 5},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 5},
  [132] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_boundary_assertion] = ACTIONS(1),
    [sym_non_boundary_assertion] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(1),
    [sym_pattern_character] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_COLON] = ACTIONS(1),
    [anon_sym_COLON_RBRACK] = ACTIONS(1),
    [anon_sym_BSLASH_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASHk] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_decimal_escape] = ACTIONS(1),
    [aux_sym_character_class_escape_token1] = ACTIONS(1),
    [aux_sym_character_class_escape_token2] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(1),
    [aux_sym_control_escape_token1] = ACTIONS(1),
    [aux_sym_control_escape_token2] = ACTIONS(1),
    [sym_control_letter_escape] = ACTIONS(1),
    [sym_identity_escape] = ACTIONS(1),
  },
  [1] = {
    [sym_pattern] = STATE(108),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [2] = {
    [sym_pattern] = STATE(113),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [3] = {
    [sym_pattern] = STATE(114),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [4] = {
    [sym_pattern] = STATE(118),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [5] = {
    [sym_pattern] = STATE(127),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [6] = {
    [sym_pattern] = STATE(111),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [7] = {
    [sym_pattern] = STATE(130),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [8] = {
    [sym_pattern] = STATE(125),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [9] = {
    [sym_pattern] = STATE(119),
    [sym_alternation] = STATE(106),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(83),
    [aux_sym_term_repeat1] = STATE(12),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [10] = {
    [sym_term] = STATE(89),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(35),
    [anon_sym_PIPE] = ACTIONS(35),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(35),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
  [11] = {
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(37),
    [sym_any_character] = ACTIONS(39),
    [anon_sym_CARET] = ACTIONS(42),
    [sym_end_assertion] = ACTIONS(39),
    [sym_boundary_assertion] = ACTIONS(39),
    [sym_non_boundary_assertion] = ACTIONS(39),
    [anon_sym_LPAREN_QMARK] = ACTIONS(45),
    [anon_sym_RPAREN] = ACTIONS(37),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(48),
    [sym_pattern_character] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACK_COLON] = ACTIONS(54),
    [anon_sym_LPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(60),
    [anon_sym_BSLASHk] = ACTIONS(63),
    [sym_decimal_escape] = ACTIONS(39),
    [aux_sym_character_class_escape_token1] = ACTIONS(66),
    [aux_sym_character_class_escape_token2] = ACTIONS(69),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(72),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(72),
    [aux_sym_control_escape_token1] = ACTIONS(75),
    [aux_sym_control_escape_token2] = ACTIONS(78),
    [sym_control_letter_escape] = ACTIONS(39),
    [sym_identity_escape] = ACTIONS(81),
  },
  [12] = {
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(21),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(84),
    [anon_sym_PIPE] = ACTIONS(84),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(84),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [aux_sym_control_escape_token1] = ACTIONS(29),
    [aux_sym_control_escape_token2] = ACTIONS(31),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(33),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(90), 1,
      anon_sym_STAR,
    ACTIONS(92), 1,
      anon_sym_QMARK,
    ACTIONS(94), 1,
      anon_sym_PLUS,
    ACTIONS(96), 1,
      anon_sym_LBRACE,
    STATE(54), 4,
      sym_zero_or_more,
      sym_one_or_more,
      sym_optional,
      sym_count_quantifier,
    ACTIONS(88), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(86), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [48] = 2,
    ACTIONS(100), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(98), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [82] = 2,
    ACTIONS(104), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(102), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [116] = 2,
    ACTIONS(108), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(106), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [150] = 2,
    ACTIONS(112), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(110), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [184] = 2,
    ACTIONS(116), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(114), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [218] = 2,
    ACTIONS(120), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(118), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [252] = 2,
    ACTIONS(124), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(122), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [286] = 2,
    ACTIONS(128), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(126), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [320] = 2,
    ACTIONS(132), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(130), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [354] = 2,
    ACTIONS(136), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(134), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [388] = 2,
    ACTIONS(140), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(138), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [422] = 2,
    ACTIONS(144), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(142), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [456] = 2,
    ACTIONS(148), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(146), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [490] = 2,
    ACTIONS(152), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(150), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [524] = 2,
    ACTIONS(156), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(154), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [558] = 2,
    ACTIONS(160), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(158), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [592] = 2,
    ACTIONS(164), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(162), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [626] = 2,
    ACTIONS(168), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(166), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [660] = 2,
    ACTIONS(172), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(170), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [694] = 2,
    ACTIONS(176), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(174), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [728] = 2,
    ACTIONS(180), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(178), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [762] = 2,
    ACTIONS(184), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(182), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [796] = 2,
    ACTIONS(188), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(186), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [830] = 2,
    ACTIONS(192), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(190), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [864] = 2,
    ACTIONS(196), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(194), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [898] = 2,
    ACTIONS(200), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(198), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [932] = 2,
    ACTIONS(204), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(202), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [966] = 2,
    ACTIONS(208), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(206), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1000] = 2,
    ACTIONS(212), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(210), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1034] = 2,
    ACTIONS(216), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(214), 23,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1068] = 3,
    ACTIONS(222), 1,
      anon_sym_QMARK,
    ACTIONS(220), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(218), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1101] = 3,
    ACTIONS(228), 1,
      anon_sym_QMARK,
    ACTIONS(226), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(224), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1134] = 3,
    ACTIONS(234), 1,
      anon_sym_QMARK,
    ACTIONS(232), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(230), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1167] = 3,
    ACTIONS(240), 1,
      anon_sym_QMARK,
    ACTIONS(238), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(236), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1200] = 3,
    ACTIONS(246), 1,
      anon_sym_QMARK,
    ACTIONS(244), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(242), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1233] = 3,
    ACTIONS(252), 1,
      anon_sym_QMARK,
    ACTIONS(250), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(248), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1266] = 2,
    ACTIONS(256), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(254), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1296] = 2,
    ACTIONS(260), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(258), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1326] = 2,
    ACTIONS(264), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(262), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1356] = 2,
    ACTIONS(268), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(266), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1386] = 2,
    ACTIONS(270), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(37), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1416] = 2,
    ACTIONS(274), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(272), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1446] = 2,
    ACTIONS(278), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(276), 20,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1476] = 13,
    ACTIONS(280), 1,
      anon_sym_CARET,
    ACTIONS(282), 1,
      anon_sym_DASH,
    ACTIONS(284), 1,
      anon_sym_RBRACK,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(288), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(65), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1523] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(300), 1,
      anon_sym_DASH,
    ACTIONS(302), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(304), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1567] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(306), 1,
      anon_sym_DASH,
    ACTIONS(308), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(304), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1611] = 12,
    ACTIONS(310), 1,
      anon_sym_DASH,
    ACTIONS(313), 1,
      anon_sym_RBRACK,
    ACTIONS(315), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(321), 1,
      sym_class_character,
    ACTIONS(324), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(327), 1,
      aux_sym_character_class_escape_token2,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(330), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(333), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(318), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1655] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(336), 1,
      anon_sym_DASH,
    ACTIONS(338), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(340), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(62), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1699] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(342), 1,
      anon_sym_DASH,
    ACTIONS(344), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(304), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1743] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(350), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(58), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1787] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(352), 1,
      anon_sym_DASH,
    ACTIONS(354), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(356), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(59), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1831] = 12,
    ACTIONS(286), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(290), 1,
      sym_class_character,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(348), 1,
      anon_sym_RBRACK,
    ACTIONS(358), 1,
      anon_sym_DASH,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(70), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(304), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1875] = 9,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(360), 1,
      anon_sym_DASH,
    ACTIONS(364), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(67), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(362), 5,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
  [1910] = 1,
    ACTIONS(366), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [1926] = 1,
    ACTIONS(368), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [1942] = 1,
    ACTIONS(370), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [1958] = 2,
    ACTIONS(372), 1,
      anon_sym_DASH,
    ACTIONS(375), 12,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [1976] = 1,
    ACTIONS(184), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [1992] = 1,
    ACTIONS(362), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2008] = 1,
    ACTIONS(216), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2024] = 1,
    ACTIONS(128), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2040] = 1,
    ACTIONS(132), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2056] = 1,
    ACTIONS(176), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2072] = 9,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(377), 1,
      anon_sym_DASH,
    ACTIONS(379), 1,
      anon_sym_RBRACK,
    ACTIONS(381), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(67), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2103] = 9,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(377), 1,
      anon_sym_DASH,
    ACTIONS(381), 1,
      sym_class_character,
    ACTIONS(383), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(67), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2134] = 8,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(360), 1,
      anon_sym_DASH,
    ACTIONS(381), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(67), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2162] = 8,
    ACTIONS(292), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(385), 1,
      anon_sym_DASH,
    ACTIONS(387), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(296), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(298), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(68), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2190] = 4,
    ACTIONS(391), 1,
      anon_sym_DASH,
    ACTIONS(393), 1,
      aux_sym_posix_class_name_token1,
    STATE(86), 1,
      sym_flags,
    ACTIONS(389), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [2204] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(84), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(395), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2215] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(84), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(397), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2226] = 3,
    ACTIONS(401), 1,
      anon_sym_PIPE,
    STATE(84), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(399), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2237] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(82), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(404), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2248] = 3,
    ACTIONS(406), 1,
      anon_sym_RPAREN,
    ACTIONS(408), 1,
      anon_sym_DASH,
    ACTIONS(410), 1,
      anon_sym_COLON,
  [2258] = 1,
    ACTIONS(412), 3,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_COLON,
  [2264] = 2,
    ACTIONS(416), 1,
      sym_group_name,
    ACTIONS(414), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [2272] = 1,
    ACTIONS(399), 3,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [2278] = 2,
    ACTIONS(418), 1,
      sym_unicode_property,
    STATE(129), 1,
      sym_unicode_property_value_expression,
  [2285] = 2,
    ACTIONS(420), 1,
      aux_sym_posix_class_name_token1,
    STATE(128), 1,
      sym_posix_class_name,
  [2292] = 2,
    ACTIONS(422), 1,
      anon_sym_DASH,
    ACTIONS(424), 1,
      anon_sym_RBRACK,
  [2299] = 2,
    ACTIONS(420), 1,
      aux_sym_posix_class_name_token1,
    STATE(112), 1,
      sym_posix_class_name,
  [2306] = 2,
    ACTIONS(426), 1,
      anon_sym_RBRACE,
    ACTIONS(428), 1,
      sym_decimal_digits,
  [2313] = 2,
    ACTIONS(393), 1,
      aux_sym_posix_class_name_token1,
    STATE(98), 1,
      sym_flags,
  [2320] = 2,
    ACTIONS(430), 1,
      anon_sym_COMMA,
    ACTIONS(432), 1,
      sym_decimal_digits,
  [2327] = 2,
    ACTIONS(434), 1,
      anon_sym_RPAREN,
    ACTIONS(436), 1,
      anon_sym_COLON,
  [2334] = 2,
    ACTIONS(438), 1,
      anon_sym_RPAREN,
    ACTIONS(440), 1,
      anon_sym_COLON,
  [2341] = 2,
    ACTIONS(422), 1,
      anon_sym_DASH,
    ACTIONS(442), 1,
      anon_sym_RBRACK,
  [2348] = 2,
    ACTIONS(422), 1,
      anon_sym_DASH,
    ACTIONS(444), 1,
      anon_sym_RBRACK,
  [2355] = 2,
    ACTIONS(446), 1,
      anon_sym_COMMA,
    ACTIONS(448), 1,
      anon_sym_RBRACE,
  [2362] = 2,
    ACTIONS(418), 1,
      sym_unicode_property,
    STATE(131), 1,
      sym_unicode_property_value_expression,
  [2369] = 2,
    ACTIONS(393), 1,
      aux_sym_posix_class_name_token1,
    STATE(97), 1,
      sym_flags,
  [2376] = 2,
    ACTIONS(422), 1,
      anon_sym_DASH,
    ACTIONS(450), 1,
      anon_sym_RBRACK,
  [2383] = 2,
    ACTIONS(452), 1,
      anon_sym_EQ,
    ACTIONS(454), 1,
      anon_sym_RBRACE,
  [2390] = 1,
    ACTIONS(404), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2395] = 1,
    ACTIONS(456), 1,
      anon_sym_COLON_RBRACK,
  [2399] = 1,
    ACTIONS(458), 1,
      ts_builtin_sym_end,
  [2403] = 1,
    ACTIONS(460), 1,
      sym_decimal_digits,
  [2407] = 1,
    ACTIONS(462), 1,
      sym_unicode_property,
  [2411] = 1,
    ACTIONS(464), 1,
      anon_sym_RPAREN,
  [2415] = 1,
    ACTIONS(466), 1,
      anon_sym_COLON_RBRACK,
  [2419] = 1,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
  [2423] = 1,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
  [2427] = 1,
    ACTIONS(472), 1,
      anon_sym_RBRACE,
  [2431] = 1,
    ACTIONS(474), 1,
      anon_sym_GT,
  [2435] = 1,
    ACTIONS(426), 1,
      anon_sym_RBRACE,
  [2439] = 1,
    ACTIONS(476), 1,
      anon_sym_RPAREN,
  [2443] = 1,
    ACTIONS(478), 1,
      anon_sym_RPAREN,
  [2447] = 1,
    ACTIONS(480), 1,
      sym_group_name,
  [2451] = 1,
    ACTIONS(422), 1,
      anon_sym_DASH,
  [2455] = 1,
    ACTIONS(482), 1,
      anon_sym_RBRACE,
  [2459] = 1,
    ACTIONS(484), 1,
      anon_sym_LBRACE,
  [2463] = 1,
    ACTIONS(486), 1,
      anon_sym_LT,
  [2467] = 1,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
  [2471] = 1,
    ACTIONS(490), 1,
      anon_sym_GT,
  [2475] = 1,
    ACTIONS(438), 1,
      anon_sym_RPAREN,
  [2479] = 1,
    ACTIONS(492), 1,
      anon_sym_COLON_RBRACK,
  [2483] = 1,
    ACTIONS(494), 1,
      anon_sym_RBRACE,
  [2487] = 1,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
  [2491] = 1,
    ACTIONS(498), 1,
      anon_sym_RBRACE,
  [2495] = 1,
    ACTIONS(500), 1,
      anon_sym_LBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(13)] = 0,
  [SMALL_STATE(14)] = 48,
  [SMALL_STATE(15)] = 82,
  [SMALL_STATE(16)] = 116,
  [SMALL_STATE(17)] = 150,
  [SMALL_STATE(18)] = 184,
  [SMALL_STATE(19)] = 218,
  [SMALL_STATE(20)] = 252,
  [SMALL_STATE(21)] = 286,
  [SMALL_STATE(22)] = 320,
  [SMALL_STATE(23)] = 354,
  [SMALL_STATE(24)] = 388,
  [SMALL_STATE(25)] = 422,
  [SMALL_STATE(26)] = 456,
  [SMALL_STATE(27)] = 490,
  [SMALL_STATE(28)] = 524,
  [SMALL_STATE(29)] = 558,
  [SMALL_STATE(30)] = 592,
  [SMALL_STATE(31)] = 626,
  [SMALL_STATE(32)] = 660,
  [SMALL_STATE(33)] = 694,
  [SMALL_STATE(34)] = 728,
  [SMALL_STATE(35)] = 762,
  [SMALL_STATE(36)] = 796,
  [SMALL_STATE(37)] = 830,
  [SMALL_STATE(38)] = 864,
  [SMALL_STATE(39)] = 898,
  [SMALL_STATE(40)] = 932,
  [SMALL_STATE(41)] = 966,
  [SMALL_STATE(42)] = 1000,
  [SMALL_STATE(43)] = 1034,
  [SMALL_STATE(44)] = 1068,
  [SMALL_STATE(45)] = 1101,
  [SMALL_STATE(46)] = 1134,
  [SMALL_STATE(47)] = 1167,
  [SMALL_STATE(48)] = 1200,
  [SMALL_STATE(49)] = 1233,
  [SMALL_STATE(50)] = 1266,
  [SMALL_STATE(51)] = 1296,
  [SMALL_STATE(52)] = 1326,
  [SMALL_STATE(53)] = 1356,
  [SMALL_STATE(54)] = 1386,
  [SMALL_STATE(55)] = 1416,
  [SMALL_STATE(56)] = 1446,
  [SMALL_STATE(57)] = 1476,
  [SMALL_STATE(58)] = 1523,
  [SMALL_STATE(59)] = 1567,
  [SMALL_STATE(60)] = 1611,
  [SMALL_STATE(61)] = 1655,
  [SMALL_STATE(62)] = 1699,
  [SMALL_STATE(63)] = 1743,
  [SMALL_STATE(64)] = 1787,
  [SMALL_STATE(65)] = 1831,
  [SMALL_STATE(66)] = 1875,
  [SMALL_STATE(67)] = 1910,
  [SMALL_STATE(68)] = 1926,
  [SMALL_STATE(69)] = 1942,
  [SMALL_STATE(70)] = 1958,
  [SMALL_STATE(71)] = 1976,
  [SMALL_STATE(72)] = 1992,
  [SMALL_STATE(73)] = 2008,
  [SMALL_STATE(74)] = 2024,
  [SMALL_STATE(75)] = 2040,
  [SMALL_STATE(76)] = 2056,
  [SMALL_STATE(77)] = 2072,
  [SMALL_STATE(78)] = 2103,
  [SMALL_STATE(79)] = 2134,
  [SMALL_STATE(80)] = 2162,
  [SMALL_STATE(81)] = 2190,
  [SMALL_STATE(82)] = 2204,
  [SMALL_STATE(83)] = 2215,
  [SMALL_STATE(84)] = 2226,
  [SMALL_STATE(85)] = 2237,
  [SMALL_STATE(86)] = 2248,
  [SMALL_STATE(87)] = 2258,
  [SMALL_STATE(88)] = 2264,
  [SMALL_STATE(89)] = 2272,
  [SMALL_STATE(90)] = 2278,
  [SMALL_STATE(91)] = 2285,
  [SMALL_STATE(92)] = 2292,
  [SMALL_STATE(93)] = 2299,
  [SMALL_STATE(94)] = 2306,
  [SMALL_STATE(95)] = 2313,
  [SMALL_STATE(96)] = 2320,
  [SMALL_STATE(97)] = 2327,
  [SMALL_STATE(98)] = 2334,
  [SMALL_STATE(99)] = 2341,
  [SMALL_STATE(100)] = 2348,
  [SMALL_STATE(101)] = 2355,
  [SMALL_STATE(102)] = 2362,
  [SMALL_STATE(103)] = 2369,
  [SMALL_STATE(104)] = 2376,
  [SMALL_STATE(105)] = 2383,
  [SMALL_STATE(106)] = 2390,
  [SMALL_STATE(107)] = 2395,
  [SMALL_STATE(108)] = 2399,
  [SMALL_STATE(109)] = 2403,
  [SMALL_STATE(110)] = 2407,
  [SMALL_STATE(111)] = 2411,
  [SMALL_STATE(112)] = 2415,
  [SMALL_STATE(113)] = 2419,
  [SMALL_STATE(114)] = 2423,
  [SMALL_STATE(115)] = 2427,
  [SMALL_STATE(116)] = 2431,
  [SMALL_STATE(117)] = 2435,
  [SMALL_STATE(118)] = 2439,
  [SMALL_STATE(119)] = 2443,
  [SMALL_STATE(120)] = 2447,
  [SMALL_STATE(121)] = 2451,
  [SMALL_STATE(122)] = 2455,
  [SMALL_STATE(123)] = 2459,
  [SMALL_STATE(124)] = 2463,
  [SMALL_STATE(125)] = 2467,
  [SMALL_STATE(126)] = 2471,
  [SMALL_STATE(127)] = 2475,
  [SMALL_STATE(128)] = 2479,
  [SMALL_STATE(129)] = 2483,
  [SMALL_STATE(130)] = 2487,
  [SMALL_STATE(131)] = 2491,
  [SMALL_STATE(132)] = 2495,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 1, 0, 0),
  [37] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [39] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [42] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [45] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(81),
  [48] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [51] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(57),
  [54] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(93),
  [57] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(3),
  [60] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [63] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(124),
  [66] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(21),
  [69] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [84] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [86] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [88] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [90] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [92] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [94] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [96] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [98] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 2),
  [100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 2),
  [102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 7, 0, 0),
  [104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 7, 0, 0),
  [106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 2, 0, 0),
  [112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 2, 0, 0),
  [114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 3, 0, 0),
  [120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 3, 0, 0),
  [122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 0),
  [124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 0),
  [126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 4, 0, 0),
  [148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 4, 0, 0),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 3),
  [156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 3),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 5),
  [164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 5),
  [166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 2),
  [168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 2),
  [170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backreference_escape, 4, 0, 0),
  [172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backreference_escape, 4, 0, 0),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 5, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 5, 0, 0),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 8),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 8),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 3),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 3),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 9),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 9),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 10),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 10),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 6, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 6, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 6, 0, 13),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 6, 0, 13),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_control_escape, 1, 0, 0),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_control_escape, 1, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 1, 0, 0),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 1, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 2, 0, 1),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 2, 0, 1),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(121),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(70),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(74),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(132),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(71),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 4),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 6),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 0),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 3),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0), SHIFT(80),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 2, 0, 0),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 1, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flags, 1, 0, 0),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 1, 0, 0),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_posix_class_name, 1, 0, 0),
  [458] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 3, 0, 11),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_regex(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
